captureEventActive = false;
CaptureWindowLive = false;
local CapturePodAvailable = false;
-- local WindowState = WowkemonCaptureFrame:isShown()
local activeWowkemonID = nil;
WowkemonCubeButtonLock = false;
local CandyMultiplier = 100;
local WowkemonLevel = 0
local currentlyThrowing = false;
local activeLevel = 0;

function BeginCaptureEvent(WowkemonID,uniqueLoc)
  PlayMusic(WDir.."\\resources\\sound\\music_arcade.mp3")
  local zone =   GetRealZoneText();
  local subZone = GetSubZoneText()
  local level = selectWildWowkemonSpawnLevel()
  activeLevel = level;
  if uniqueLoc == false then
    activeWowkemonID = Wowkemons[WowkemonID]
  else
    activeWowkemonID = wowkemonUniqueSpawnLocs[subZone][WowkemonID];
 end
 -- Set the Zone backdrop to our current zone, or default to placeholder if not found.
 if ZoneTextures[zone] ~= nil then
  WowkemonCaptureFrame.Background:SetTexture(ZoneTextures[zone]);
  else
    WowkemonCaptureFrame.Background:SetTexture(ZoneTextures["Loch Modan"]);
end
-- Set the wowkemon texture to the wowkemon we've encountered
WowkemonCaptureFrame.Wowkemon:SetTexture(activeWowkemonID[2])
WowkemonCaptureFrame.WowkemonDetailText:SetText("Level "..level.." "..activeWowkemonID[1])
end


function CubeClicked(time)
  if WowkemonPlayerData["Capture Cube"] > 0 then
    if currentlyThrowing == false  then
          PlaySoundFile(WDir.."\\resources\\sound\\effect_toss.mp3")
        currentlyThrowing = true;
          clearFeedbackText()
    WowkemonPlayerData["Capture Cube"] = (WowkemonPlayerData["Capture Cube"] - 1)
    if WowkemonCubeButtonLock == false then
        WowkemonCubeButtonLock = true;
          local InitialChance = (1 - time) * 100;
  WowkemonThrowAnimation(time,InitialChance);

  setFeedbackText(InitialChance);
end
end
else
  WowkemonCaptureFrame.CaptureTextHitResult:SetText("You don't have any Capture Cubes!");
end
end

function CubeThrowAnimFinished(time,InitialChance)
  if WowkemonPlayerData["Capture Cube"] >= 0  then

    clearFeedbackText()
    --  local InitialChance = (1 - time) * 100;
    --  setFeedbackText(InitialChance);
    --  Wowkemon__wait(2.5,clearFeedbackText);
      if math.random(100) < InitialChance then
        PlaySoundFile(WDir.."\\resources\\sound\\cubeHit.mp3")
        WowkemonCaptureFrame.CaptureTextHitResult:SetText("Hit!");
        WowkemonCaptureFrame.Wowkemon:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCubeShut.tga")
        DecideIfCaptured(InitialChance);
        WowkemonCaptureFrame.Wowkemon:SetScale(0.25)
        WowkemonCaptureFrame.abortButton:Hide();
        else
          WowkemonCaptureFrame.CaptureTextHitResult:SetText("Miss!");
          unlockCubeClick()
            PlaySoundFile(WDir.."\\resources\\sound\\cubeMiss.mp3")
          currentlyThrowing = false
      end

    end
end

function DecideIfCaptured(score)

  if indexOfTargetToCapture ~= 0 then
    -- WowkemonLevel = SpawnedWowkemon[indexOfTargetToCapture][3];
else
  WowkemonLevel = 14;
end
local PlayerLevel = WowkemonPlayerData["level"];
local finalChance = score
if
  PlayerLevel <= activeLevel then
    if activeLevel - PlayerLevel < 5 then
      finalChance  =  math.max(score - ((activeLevel / PlayerLevel)),2)
    --  print(finalChance.."%")
  --    print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10 / 3).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
    elseif activeLevel - PlayerLevel < 10 then
        finalChance  =  math.max(score - ((activeLevel / PlayerLevel) * 10 /2 ),1)
  --      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10 / 2).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
      else
        finalChance  =  math.max(score - ((activeLevel / PlayerLevel) * 10),5)
  --      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
    end
else
  finalChance = score;
end

  print("Cap chance: "..round(finalChance,2).."%")
Wowkemon__wait(1,setFeedbackStatusText,"3");
Wowkemon__wait(2,setFeedbackStatusText,"2");
Wowkemon__wait(3,setFeedbackStatusText,"1");
Wowkemon__wait(4,setFeedbackStatusText,"");
Wowkemon__wait(4,ActionCaptureDecision,finalChance,activeLevel);
end

function ActionCaptureDecision(chance,activeLevel)
  StopMusic();
if math.random(100) < chance then
  -- captured!
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Caught!!")
    WowkemonCaptureFrame.CaptureTextHitResult:SetText("Nice!");
        PlaySoundFile(WDir.."\\resources\\sound\\jingle_achieve.mp3")
    WowkemonPlayerData["XP"] = WowkemonPlayerData["XP"] + (100 * activeLevel)
    Wowkemon__wait(2,updateWowkedex,activeWowkemonID,activeLevel)
    WowkemonCaughtEvent()
    checkCapQuestStatus()
else
  -- broke free!
    WowkemonCaptureFrame.CaptureTextClickResult:SetText("Wowkemon got away.")
      WowkemonCaptureFrame.CaptureTextHitResult:SetText("Unlucky!");
    PlaySoundFile(WDir.."\\resources\\sound\\jingle_lose.mp3")

    WowkemonCaptureFrame.Wowkemon:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCubeBroken.tga")
    WowkemonCaptureFrame.closeButton:Show()

end

end

function checkCapQuestStatus()
  for e in pairs(WowkemonPlayerData["quests"]) do
    if WowkemonPlayerData["quests"][e][1] == "capture" and WowkemonPlayerData["quests"][e][2] == GetZoneText() then
      table.remove(WowkemonPlayerData["quests"],e);
      print("|cffFFff00 Wowkemon Quest Complete!|r")
      WowkemonAddItem("Capture Cube",math.random(10));
    end
  end
end
-- Update the display text to reflect the shot accuracy
function setFeedbackText(result)
  if result > 90 then
WowkemonCaptureFrame.CaptureTextClickResult:SetText("Excellent!")
elseif result > 80 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Great!")
elseif result > 70 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("OK!")
elseif result > 50 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Weak!")
elseif result > 30 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Bad!")
else
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Terrible!")
end
end

function setFeedbackStatusText(text)
    WowkemonCaptureFrame.CaptureTextHitResult:SetText(text);
end

function clearFeedbackText()
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("")
  WowkemonCaptureFrame.CaptureTextHitResult:SetText("");
end

function unlockCubeClick()
WowkemonCubeButtonLock = false;
  currentlyThrowing =false;
end


function updateWowkedex(Wowkemon,level)
if  WowkemonPlayerData["Wowkedex"][Wowkemon[1]] == nil then
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]] = {level*CandyMultiplier,1,level}
   -- WowkemonPlayerData["Wowkedex"][Wowkemon][1] = (level * CandyMultiplier)  print("|r")
    print("|cffFFff00 You caught a new Wowkemon! \n"..Wowkemon[1].." added to Wowkedex! |r")
    addToWowkedexList(Wowkemon)

  else
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][1] = WowkemonPlayerData["Wowkedex"][Wowkemon[1]][1] + (level * CandyMultiplier);
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][2] = WowkemonPlayerData["Wowkedex"][Wowkemon[1]][2] + 1;
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][3] = math.max(WowkemonPlayerData["Wowkedex"][Wowkemon[1]][3],level);
end

WowkemonCaptureFrame.CaptureTextClickResult:SetText("XP:"..(level*100).." \n".."Candy: "..level * CandyMultiplier)
WowkemonCaptureFrame.closeButton:Show()

end

function WowkemonThrowAnimation(time,InitialChance)
  local AnimGroup = WowkemonCaptureFrame.CaptureItem:CreateAnimationGroup("CubeAnimationGrp",WowkemonCaptureFrame)
  local Anim = AnimGroup:CreateAnimation("Translation")

   Anim:SetOffset(-115,115)
   Anim:SetDuration(1)
    AnimGroup:Play()
  Wowkemon__wait(1,CubeThrowAnimFinished,time,InitialChance)
end
