-- SpawnedWowkemon table structure = WowkedexIndex, SpawnCoordinates, SpawnLevel
SpawnedWowkemon = {};
local availableTypes = 0;
for entry in pairs(Wowkemons) do
  availableTypes = entry
end

function RenewSpawns(amount)
local name = GetInstanceInfo()
if name == "Eastern Kingdoms" or name == "Kalimdor" then

SpawnedWowkemon = {};
  if amount == nil then
    amount = 20
  end
for i = 1,amount,1 do
  local spawnData = {};
  local randomIndex = math.random(availableTypes);
   spawnData[3] = selectWildWowkemonSpawnLevel()
   spawnData[2] = SelectRandomSpawnCoordinate()
   spawnData[1] = randomIndex;
   table.insert(SpawnedWowkemon,spawnData)
end
end
end

function selectWildWowkemonSpawnLevel(notRandom,level)
--  local chosenLevel = 1;
--  if notRandom == false or notRandom == nil then
local playerLevel =  WowkemonPlayerData["level"];
local SpawnChance = playerLevel / 30
local randomRoll =  math.random()
local chosenLevel = 0;
if randomRoll < SpawnChance then
  -- Highest Level Spawn Chance succeeded
  chosenLevel = math.random(25,30)
--  return chosenLevel
else
  SpawnChance = playerLevel / 20
  randomRoll = math.random()
  if randomRoll < SpawnChance then
  -- Level 20 Spawn range succeeded
  chosenLevel = math.random(20,25)
--  return chosenLevel
  else
    SpawnChance = playerLevel / 15
    randomRoll = math.random()
    if randomRoll < SpawnChance then
      -- Level 15 Spawn chance succeeded
      chosenLevel = math.random(10,20)
  --    return chosenLevel
    else
      SpawnChance = playerLevel / 10
      randomRoll = math.random()
      if randomRoll < SpawnChance then
        -- Level 10 Spawn chance succeeded
        chosenLevel = math.random(5,10)
  --      return chosenLevel
      else
        -- All higher spawn chance failed, select 1-5
        chosenLevel = math.random(5)
      end
    end
  end
end
return chosenLevel
end

function SelectRandomSpawnCoordinate()
local locationX = round(math.random() * 100,1)
local locationY = round(math.random() * 100,1)
--print ("Spawning at" ..locationX.." - "..locationY)
return({locationX,locationY})
end

function SpawnAtPlayerLocation(level)
  local spawnLevel = selectWildWowkemonSpawnLevel()
  if level ~= nil then
    spawnLevel = selectWildWowkemonSpawnLevel(true,level)
  end
local SpawnLoc = C_Map.GetPlayerMapPosition(C_Map.GetBestMapForUnit("player"),"player")
local NewSpawnRandex =math.random(availableTypes);
local newSpawnData = {};
 newSpawnData[3] = spawnLevel
 newSpawnData[2] = {SpawnLoc.x*100,SpawnLoc.y*100}
 newSpawnData[1] = NewSpawnRandex;
 table.insert(SpawnedWowkemon,newSpawnData)
end
